//--------------------------------------------------------------------
//                                                                    
//  Module:       SalesOrder                                       
//  Description:  SalesOrder
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SalesOrder extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	Panel Panel1;
	JDPTextGrid DetailGrid1;
	Panel Columns1;
	JDPScrollPanel ScrollPanel1;
	Label stor_idLabel1;
	TextField stor_id1;
	Label stor_nameLabel1;
	TextField stor_name1;
	Label stor_addressLabel1;
	TextField stor_address1;
	Label cityLabel1;
	Panel cityLine1;
	TextField city1;
	TextField state1;
	TextField zip1;
	JDPButtons JDPButtons1;
	Panel Panel2;
	JDPSearchResults ResultList1;
	JDPWhereClause SearchPanel1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		this.targetPanel = targetPanel;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		Panel1 = new Panel();
		DetailGrid1Main();
		Columns1 = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		stor_idLabel1 = new Label("Store Id:", Label.LEFT);
		stor_id1 = new TextField("stor_id", 6);
		stor_nameLabel1 = new Label("Name:", Label.LEFT);
		stor_name1 = new TextField("stor_name", 42);
		stor_addressLabel1 = new Label("Address:", Label.LEFT);
		stor_address1 = new TextField("stor_address", 42);
		cityLabel1 = new Label("", Label.LEFT);
		cityLine1 = new Panel();
		city1 = new TextField("city", 22);
		state1 = new TextField("state", 4);
		zip1 = new TextField("zip", 7);
		String[] JDPButtons1btns = {"Save","Delete","Reset"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("Save"),JDPButton.getIconValue("Delete"),JDPButton.getIconValue("Undo")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		Panel2 = new Panel();
		ResultList1Main();
		SearchPanel1Main();

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("Center", DetailGrid1);
		Panel1.add("North", Columns1);
		Columns1.setLayout(new BorderLayout());
		Columns1Main();
		Columns1.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", stor_idLabel1);
		ScrollPanel1.add("Right", stor_id1);
		ScrollPanel1.add("Left", stor_nameLabel1);
		ScrollPanel1.add("Right", stor_name1);
		ScrollPanel1.add("Left", stor_addressLabel1);
		ScrollPanel1.add("Right", stor_address1);
		ScrollPanel1.add("Left", cityLabel1);
		ScrollPanel1.add("Right", cityLine1);
		cityLine1.setLayout(new JDPLineLayout());
		cityLine1.add("Left", city1);
		cityLine1.add("Left", state1);
		cityLine1.add("Left", zip1);
		Panel1.add("South", JDPButtons1);
		Main.add("West", Panel2);
		Panel2.setLayout(new BorderLayout());
		Panel2.add("Center", ResultList1);
		Panel2.add("North", SearchPanel1);

		popuppanel.addComponent(stor_id1 ,"Stor Id" ,"");
		popuppanel.addComponent(stor_name1 ,"Stor  name" ,"");
		popuppanel.addComponent(stor_address1 ,"Stor Address" ,"");
		popuppanel.addComponent(city1 ,"City" ,"");
		popuppanel.addComponent(state1 ,"State" ,"");
		popuppanel.addComponent(zip1 ,"Zip" ,"");
		popuppanel.addComponent(JDPButtons1.button[0] ,"Save Changes" ,"Save changes to the database");
		popuppanel.addComponent(JDPButtons1.button[1] ,"Delete Rows" ,"Remove the selected rows from this order");
		popuppanel.addComponent(JDPButtons1.button[2] ,"Restore" ,"Restore this order from the database");


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButtons1.button[0])) {
				DetailGrid1UpdateRows(ResultList1.getSelectedKey());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[1])) {
				DetailGrid1DeleteRows(ResultList1.getSelectedKey());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[2])) {
				DetailGrid1LoadGrid(ResultList1.getSelectedKey());
				return true;
			}
			if (e.target.equals(ResultList1)) {
				Columns1Load(ResultList1.getSelectedKey());
				DetailGrid1LoadGrid(ResultList1.getSelectedKey());
				return true;
			}
			if (e.target.equals(SearchPanel1)) {
				ResultList1.clearList();
				ResultList1.setFromWhereClause(SearchPanel1.getFromWhereClause());
				ResultList1.loadList();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}

	//
	//  Main initialization method
	//
	public void DetailGrid1Main() {

		DetailGrid1SetGridSettings();

	}

	//
	//  Load the grid with the specified parameters and selected data
	//
	public void DetailGrid1LoadGrid(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		int columnCount = 3;

		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT stor_id, " +
					"ord_num, " +
					"title_id, " +
					"title_id, " +
					"qty, " +
					"payterms FROM dbo_sales WHERE (1=1)  ";
		if (keys.length > 0 && keys[0] != null) SQL += " AND stor_id='" + keys[0]+ "'" ;
		if (keys.length > 1 && keys[1] != null) SQL += " AND ord_num='" + keys[1]+ "'" ;
		if (keys.length > 2 && keys[2] != null) SQL += " AND title_id='" + keys[2]+ "'" ;

		user.mainmsg.setStatusMsg("Accessing database...", 0);

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		//
		//  Initialise result arrays
		//
		tableContents.totalDataRows = jaggSQL.getRowCount();
		actualRows = jaggSQL.getRowCount()+20;
		tableContents.currentText = new String[columnCount][actualRows];

		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		int keyCount = 3;
		tableContents.rowKey = new String[actualRows][keyCount];
		
		//
		//  Load key array and grid array
		//
		String tempText;
		for (int ix=0; ix<actualRows-20; ix++) {
			row = (String)results.elementAt(ix);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row);
				for (int iy=0; iy<keyCount; iy++) {
					tableContents.rowKey[ix][iy] = stok.nextToken(sep).trim();
				}
				for (int iy=0; iy<columnCount; iy++) {
					tempText = stok.nextToken(sep).trim();
					tableContents.currentText[iy][ix] = tempText;
					if ((iy == 0) && (tableContents.pullDownValue[0][0].indexOf(tempText) >= 0)) tableContents.currentText[iy][ix] = tableContents.pullDownList[0][0].getItem(tableContents.pullDownValue[0][0].indexOf(tempText));
					if ((iy == 2) && (tableContents.pullDownValue[2][0].indexOf(tempText) >= 0)) tableContents.currentText[iy][ix] = tableContents.pullDownList[2][0].getItem(tableContents.pullDownValue[2][0].indexOf(tempText));
				}
			}
		}
		for (int ix=actualRows-20; ix<actualRows; ix++) {
			for (int iy=0; iy<keys.length; iy++) {
				tableContents.rowKey[ix][iy] = keys[iy];
			}
		}

		tableContents.newTable();

		//
		//  Clear status message
		//
		user.mainmsg.clearStatusMsg();
	}

	//
	//  Check each row that has changed and issue an update to the database
	//
	public void DetailGrid1UpdateRows(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		int changedCount = 0;
		int insertedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					insertedCount++;
				} else {
					changedCount++;
				}
			}
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					user.mainmsg.setStatusMsg("Inserting row " + Integer.toString(iCount++) + " of " + Integer.toString(insertedCount) + "...", 0);
					DetailGrid1SaveData(ix,"I");
				} else {
					user.mainmsg.setStatusMsg("Updating row " + Integer.toString(cCount++) + " of " + Integer.toString(changedCount) + "...", 0);
					DetailGrid1SaveData(ix,"U");
				}
				tableContents.rowChanged[ix] = false;
			}
		}
		if (insertedCount > 0) {
			DetailGrid1LoadGrid(keys);
		}
	}

	//
	//  Delete any of the selected rows
	//
	public void DetailGrid1DeleteRows(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		int deletedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				deletedCount++;
			} 
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				user.mainmsg.setStatusMsg("Deleting row " + Integer.toString(iCount++) + " of " + Integer.toString(deletedCount) + "...", 0);
				DetailGrid1SaveData(ix,"D");
			}
		}
		if (deletedCount > 0) {
			DetailGrid1LoadGrid(keys);
		}
	}

	//
	//  Save the selected item
	//
	boolean DetailGrid1SaveData(int tableRow, String action) {

		JDPTextGrid tableContents = DetailGrid1;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_sales (stor_id, " +
					"ord_num, " +
					"title_id, " +
					"qty, " +
					"payterms) VALUES('" + tableContents.rowKey[tableRow][0] + "', " +
					"'" + tableContents.rowKey[tableRow][1] + "', " +
					"'" + (String)tableContents.pullDownValue[0][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[0][0],tableContents.currentText[0][tableRow])) + "', " +
					"" + tableContents.currentText[1][tableRow] + ", " +
					"'" + (String)tableContents.pullDownValue[2][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[2][0],tableContents.currentText[2][tableRow])) + "')";
		} else {
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_sales" +
					" WHERE stor_id='" + tableContents.rowKey[tableRow][0] + "'"  +
					" AND ord_num='" + tableContents.rowKey[tableRow][1] + "'"  +
					" AND title_id='" + tableContents.rowKey[tableRow][2] + "'" ;
			} else {
				SQL = "UPDATE dbo_sales SET qty = " + tableContents.currentText[1][tableRow] + ", " +
					"payterms = '" + (String)tableContents.pullDownValue[2][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[2][0],tableContents.currentText[2][tableRow])) + "'" +
					" WHERE stor_id='" + tableContents.rowKey[tableRow][0] + "'"  +
					" AND ord_num='" + tableContents.rowKey[tableRow][1] + "'"  +
					" AND title_id='" + tableContents.rowKey[tableRow][2] + "'" ;
			}
		}

		recCount = jaggSQL.execSQL(SQL, results);

		if (user.DEBUG) System.out.println("saveData CNT: "+Integer.toString(recCount));

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if(recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg("Record successfully added.",3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg("Record successfully removed.",3);
			} else {
				user.mainmsg.setStatusMsg("Record successfully updated.",3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		return true;

	}

	//
	//  Load the grid with the blank rows to allow data entry
	//
	public void DetailGrid1LoadEmptyGrid() {

		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 3;

		tableContents.currentText = new String[columnCount][50];
		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		tableContents.rowKey = new String[50][1];
		tableContents.newTable();
		tableContents.totalDataRows = 0;
	}

	//
	//  Set up the parameters for this grid
	//
	void DetailGrid1SetGridSettings() {

		if (DetailGrid1 == null) {
			DetailGrid1 = new JDPTextGrid(user);
		} 
		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 3;

		tableContents.columnHeader = new String[columnCount];
		tableContents.columnHeaderStyle = new int[columnCount];
		tableContents.columnStyle = new int[columnCount];
		tableContents.columnHeaderColor = new Color[columnCount];
		tableContents.columnColor = new Color[columnCount];
		tableContents.columnBGColor = new Color[columnCount];
		tableContents.columnProtected = new boolean[columnCount];
		tableContents.columnWidth = new int[columnCount];
		tableContents.rightJustify = new boolean[columnCount];
		tableContents.rowHeader = null;
		tableContents.columnHeight = null;
		for (int ix=0; ix<columnCount; ix++) {
			tableContents.columnHeaderStyle[ix] = Font.BOLD;
			tableContents.columnStyle[ix] = Font.PLAIN;
			tableContents.columnHeaderColor[ix] = Color.black;
			tableContents.columnColor[ix] = Color.black;
			tableContents.columnBGColor[ix] = Color.white;
			tableContents.columnStyle[ix] = Font.PLAIN;
		}
		tableContents.columnProtected[0] = true;
		tableContents.columnProtected[2] = true;
		tableContents.columnWidth[0] = 265;
		tableContents.columnWidth[1] = 32;
		tableContents.columnWidth[2] = 98;
		tableContents.rightJustify[1] = true;
		tableContents.columnHeader[0] = "Title Id";
		tableContents.columnHeader[1] = "Qty";
		tableContents.columnHeader[2] = "Payterms";

		DetailGrid1LoadEmptyGrid();
		DetailGrid1LoadChoices();
	}

	//
	//  Load all of the Screen Choices
	//
	void DetailGrid1LoadChoices() {

		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 3;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		tableContents.isPullDownCol = new boolean[columnCount];
		tableContents.pullDownList = new List[columnCount][1];
		tableContents.isPullDownCol[0] = true;
		tableContents.isPullDownCol[2] = true;
		tableContents.pullDownList[0][0] = new List();
		tableContents.pullDownList[2][0] = new List();

		tableContents.pullDownValue[2][0] = new Vector(); 
		tableContents.pullDownList[2][0].addItem("Net 30"); 
		tableContents.pullDownValue[2][0].addElement("Net 30"); 
		tableContents.pullDownList[2][0].addItem("Net 60"); 
		tableContents.pullDownValue[2][0].addElement("Net 60"); 
		tableContents.pullDownList[2][0].addItem("ON invoice"); 
		tableContents.pullDownValue[2][0].addElement("ON invoice"); 

		tableContents.pullDownValue[0][0] = new Vector(); 
		new JDPLoadChoice(user,jaggSQL,tableContents.pullDownList[0][0],"title","title_id","dbo_titles","(1=1)",tableContents.pullDownValue[0][0]);
	}

	//
	//  Main initialization method
	//
	public void Columns1Main() {

		Columns1LoadChoices();
		Columns1ClearFields();

	}

	//
	//  Load the selected item
	//
	public void Columns1Load(String[] keys) {

		StringTokenizer stok;

		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		String tempText;

		if (keys == null || keys.length < 0) {
			Columns1ClearFields();
			return;
		}

		String SQL = "SELECT stor_id," +
					"stor_name," +
					"stor_address," +
					"city," +
					"state," +
					"zip" +
					" FROM dbo_stores" +
					" WHERE (1=1)";
		if (keys.length > 0 && keys[0] != null) SQL += " AND stor_id='" + keys[0]+ "'" ;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("");
		jaggSQL.setJdbcPrefix("");
		jaggSQL.setJdbcSuffix("");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		user.mainmsg.setStatusMsg("Accessing database...", 0);
		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}
		if(recCount >= 1) {
			row = (String)results.elementAt(0);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row);
				stor_id1.setText(stok.nextToken(sep).trim());
				stor_name1.setText(stok.nextToken(sep).trim());
				stor_address1.setText(stok.nextToken(sep).trim());
				city1.setText(stok.nextToken(sep).trim());
				state1.setText(stok.nextToken(sep).trim());
				zip1.setText(stok.nextToken(sep).trim());
			}
			if(recCount > 1) {
				user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
			} else {
				user.mainmsg.clearStatusMsg();
			}
		} else {
			user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
			Columns1ClearFields();
		}

	}

	//
	//  Update the selected item
	//
	public boolean Columns1updateRow(String[] keys) {

		if (Columns1CheckFields()) {
			return Columns1Save(keys, "U");
		}
		return false;
	}

	//
	//  Insert the selected item
	//
	public boolean Columns1insertRow(String[] keys) {

		if (Columns1CheckFields()) {
			return Columns1Save(keys, "I");
		}
		return false;
	}

	//
	//  Remove the selected item
	//
	public boolean Columns1removeRow(String[] keys) {

		return Columns1Save(keys, "D");
	}

	//
	//  Save the selected item
	//
	boolean Columns1Save(String[] keys, String action) {

		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_stores (stor_id, " +
					"stor_name, " +
					"stor_address, " +
					"city, " +
					"state, " +
					"zip) VALUES('" + user.u.replace(stor_id1.getText(),"'","''") + "', " +
					"'" + user.u.replace(stor_name1.getText(),"'","''") + "', " +
					"'" + user.u.replace(stor_address1.getText(),"'","''") + "', " +
					"'" + user.u.replace(city1.getText(),"'","''") + "', " +
					"'" + user.u.replace(state1.getText(),"'","''") + "', " +
					"'" + user.u.replace(zip1.getText(),"'","''") + "')";
		} else {
			if (keys == null || keys.length == 0) {
				user.mainmsg.setStatusMsg("You must first make a selection",5);
				return false;
			}
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_stores" +
					" WHERE stor_id='" + keys[0]+ "'" ;
			} else {
				SQL = "UPDATE dbo_stores SET stor_name = '" + user.u.replace(stor_name1.getText(),"'","''") + "', " +
					"stor_address = '" + user.u.replace(stor_address1.getText(),"'","''") + "', " +
					"city = '" + user.u.replace(city1.getText(),"'","''") + "', " +
					"state = '" + user.u.replace(state1.getText(),"'","''") + "', " +
					"zip = '" + user.u.replace(zip1.getText(),"'","''") + "'" +
					" WHERE stor_id='" + keys[0]+ "'" ;
			}
		}

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("");
		jaggSQL.setJdbcPrefix("");
		jaggSQL.setJdbcSuffix("");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		user.mainmsg.setStatusMsg("Accessing database...", 0);
		recCount = jaggSQL.execSQL(SQL, results);

		if (recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if (recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg("Record successfully added.",3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg("Record successfully removed.",3);
			} else {
				user.mainmsg.setStatusMsg("Record successfully updated.",3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		return true;

	}

	//
	//  Clear the screen fields for a new option
	//
	public void Columns1ClearFields() {

		stor_id1.setText("");
		stor_name1.setText("");
		stor_address1.setText("");
		city1.setText("");
		state1.setText("");
		zip1.setText("");

	}

	//
	//  Load all of the Screen Choices
	//
	void Columns1LoadChoices() {

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("");
		jaggSQL.setJdbcPrefix("");
		jaggSQL.setJdbcSuffix("");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

	}

	//
	//  Perform component validations
	//
	public boolean Columns1CheckFields() {


		return true;

	}

	//
	//  Create and load the Result List Panel
	//
	public void ResultList1Main() {

		String ResultList1sf = "a.stor_id,a.ord_num";
		String[] ResultList1df = {"a.ord_num"};
		String ResultList1wc = "(1=1)";
		String[] ResultList1sct = {"Store  name","Store Address"};
		String[] ResultList1sc = {"b.stor_name","b.stor_address"};
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		ResultList1 = new JDPSearchResults(user, targetPanel, true, jaggSQL, false, ResultList1sf, ResultList1df, ResultList1wc, ResultList1sct, ResultList1sc, ResultList1sc, "", true, "Total Entries:");
		int[] ResultList1icons = new int[5];
		ResultList1icons[0] = 3;
		ResultList1icons[1] = 5;
		ResultList1icons[2] = 8;
		ResultList1.setMinWidth(170);
		ResultList1.setIcons(ResultList1icons);
		ResultList1.setFromWhereClause(" FROM dbo_sales a,dbo_stores b WHERE a.stor_id = b.stor_id AND (1=1)");
		ResultList1.clearList("");
		ResultList1.loadList();
	}

	//
	//  Create and load the Search Panel
	//
	public void SearchPanel1Main() {

		String[] SearchPanel1cf = new String[6];
		String[] SearchPanel1acf = new String[6];
		Vector SearchPanel1mu = new Vector();
		Vector SearchPanel1amu = new Vector();
		SearchPanel1cf[0] = "Order Num";
		SearchPanel1acf[0] = "a.ord_num";
		SearchPanel1cf[1] = "Quantity";
		SearchPanel1acf[1] = "a.qty";
		SearchPanel1cf[2] = "Store name";
		SearchPanel1acf[2] = "b.stor_name";
		SearchPanel1cf[3] = "Store Address";
		SearchPanel1acf[3] = "b.stor_address";
		SearchPanel1cf[4] = "City";
		SearchPanel1acf[4] = "b.city";
		SearchPanel1cf[5] = "State";
		SearchPanel1acf[5] = "b.state";
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		((Vector)SearchPanel1mu.elementAt(0)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(0)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(0)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(0)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(1)).addElement("Greater than");
		((Vector)SearchPanel1amu.elementAt(1)).addElement(">");
		((Vector)SearchPanel1mu.elementAt(1)).addElement("Less than");
		((Vector)SearchPanel1amu.elementAt(1)).addElement("<");
		((Vector)SearchPanel1mu.elementAt(1)).addElement("Equal to");
		((Vector)SearchPanel1amu.elementAt(1)).addElement("=");
		((Vector)SearchPanel1mu.elementAt(2)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(2)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(2)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(2)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(3)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(3)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(3)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(3)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(4)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(4)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(4)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(4)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(5)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(5)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(5)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(5)).addElement("like");
		int[] SearchPanel1cl = new int[6];
		boolean[] SearchPanel1cis = new boolean[6];
		SearchPanel1cl[0] = 8;
		SearchPanel1cis[0] = true;
		SearchPanel1cl[1] = 24;
		SearchPanel1cis[1] = false;
		SearchPanel1cl[2] = 20;
		SearchPanel1cis[2] = true;
		SearchPanel1cl[3] = 6;
		SearchPanel1cis[3] = true;
		SearchPanel1cl[4] = 16;
		SearchPanel1cis[4] = true;
		SearchPanel1cl[5] = 10;
		SearchPanel1cis[5] = true;
		SearchPanel1 = new JDPWhereClause(user, targetPanel, "", true, "Stor name", SearchPanel1cf, SearchPanel1acf, SearchPanel1mu, SearchPanel1amu, null, null, SearchPanel1cl, SearchPanel1cis, "FROM dbo_sales a,dbo_stores b WHERE a.stor_id = b.stor_id AND (1=1)");
	}


}

