//--------------------------------------------------------------------
//                                                                    
//  Module:       StoreInquiry                                       
//  Description:  StoreInquiry
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class StoreInquiry extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	Panel Columns1;
	JDPScrollPanel ScrollPanel1;
	Label stor_idLabel1;
	TextField stor_id1;
	Label stor_nameLabel1;
	TextField stor_name1;
	Label stor_addressLabel1;
	TextField stor_address1;
	Label cityLabel1;
	JDPChoice city1;
	Vector valuecity1;
	Label stateLabel1;
	Panel stateLine1;
	Checkbox state1;
	Checkbox state11;
	Checkbox state12;
	Label zipLabel1;
	JDPComboBox zip1;
	Vector valuezip1;
	JDPSearchResults ResultList1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		CheckboxGroup cbGroup4 = new CheckboxGroup();
		Main = new Panel();
		Columns1 = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		stor_idLabel1 = new Label("Stor Id:", Label.LEFT);
		stor_id1 = new TextField("stor_id", 6);
		stor_nameLabel1 = new Label("Stor name:", Label.LEFT);
		stor_name1 = new TextField("stor_name", 42);
		stor_addressLabel1 = new Label("Stor Address:", Label.LEFT);
		stor_address1 = new TextField("stor_address", 42);
		cityLabel1 = new Label("City:", Label.LEFT);
		city1 = new JDPChoice();
		stateLabel1 = new Label("State:", Label.LEFT);
		stateLine1 = new Panel();
		state1 = new Checkbox("CA", cbGroup4, false);
		state11 = new Checkbox("WA", cbGroup4, false);
		state12 = new Checkbox("OR", cbGroup4, false);
		zipLabel1 = new Label("Zip:", Label.LEFT);
		zip1 = new JDPComboBox(user);
		ResultList1Main();

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", Columns1);
		Columns1.setLayout(new BorderLayout());
		Columns1Main();
		Columns1.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", stor_idLabel1);
		ScrollPanel1.add("Right", stor_id1);
		ScrollPanel1.add("Left", stor_nameLabel1);
		ScrollPanel1.add("Right", stor_name1);
		ScrollPanel1.add("Left", stor_addressLabel1);
		ScrollPanel1.add("Right", stor_address1);
		ScrollPanel1.add("Left", cityLabel1);
		ScrollPanel1.add("Right", city1);
		ScrollPanel1.add("Left", stateLabel1);
		ScrollPanel1.add("Right", stateLine1);
		stateLine1.setLayout(new JDPLineLayout());
		stateLine1.add("Left", state1);
		stateLine1.add("Left", state11);
		stateLine1.add("Left", state12);
		ScrollPanel1.add("Left", zipLabel1);
		ScrollPanel1.add("Right", zip1);
		Main.add("West", ResultList1);

		popuppanel.addComponent(stor_id1 ,"Stor Id" ,"");
		popuppanel.addComponent(stor_name1 ,"Stor name" ,"");
		popuppanel.addComponent(stor_address1 ,"Stor Address" ,"");
		popuppanel.addComponent(city1 ,"City" ,"");
		popuppanel.addComponent(state1 ,"State" ,"");
		popuppanel.addComponent(state11 ,"State" ,"");
		popuppanel.addComponent(state12 ,"State" ,"");
		popuppanel.addComponent(zip1 ,"Zip" ,"");


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(ResultList1)) {
				Columns1Load(ResultList1.getSelectedKey());
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}
	//
	//  Main initialization method
	//
	public void Columns1Main() {

		Columns1LoadChoices();
		Columns1ClearFields();

	}

	//
	//  Load the selected item
	//
	public void Columns1Load(String[] keys) {

		StringTokenizer stok;

		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		String tempText;

		if (keys == null || keys.length < 0) {
			Columns1ClearFields();
			return;
		}

		String SQL = "SELECT stor_id," +
					"stor_name," +
					"stor_address," +
					"city," +
					"state," +
					"zip" +
					" FROM dbo_stores" +
					" WHERE (1=1)";
		if (keys.length > 0 && keys[0] != null) SQL += " AND stor_id='" + keys[0]+ "'" ;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR(" ");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		user.mainmsg.setStatusMsg("Accessing database...", 0);
		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}
		if(recCount >= 1) {
			row = (String)results.elementAt(0);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row);
				stor_id1.setText(stok.nextToken(sep).trim());
				stor_name1.setText(stok.nextToken(sep).trim());
				stor_address1.setText(stok.nextToken(sep).trim());
				tempText = stok.nextToken(sep).trim(); 
				if (valuecity1.indexOf((String)tempText) >= 0) city1.select(valuecity1.indexOf((String)tempText));
				tempText = stok.nextToken(sep).trim(); 
				state1.setState(tempText.equals("CA"));
				state11.setState(tempText.equals("WA"));
				state12.setState(tempText.equals("OR"));
				zip1.setText(stok.nextToken(sep).trim());
			}
			if(recCount > 1) {
				user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
			} else {
				user.mainmsg.clearStatusMsg();
			}
		} else {
			user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
			Columns1ClearFields();
		}

	}

	//
	//  Update the selected item
	//
	public boolean Columns1updateRow(String[] keys) {

		if (Columns1CheckFields()) {
			return Columns1Save(keys, "U");
		}
		return false;
	}

	//
	//  Insert the selected item
	//
	public boolean Columns1insertRow(String[] keys) {

		if (Columns1CheckFields()) {
			return Columns1Save(keys, "I");
		}
		return false;
	}

	//
	//  Remove the selected item
	//
	public boolean Columns1removeRow(String[] keys) {

		return Columns1Save(keys, "D");
	}

	//
	//  Save the selected item
	//
	boolean Columns1Save(String[] keys, String action) {

		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_stores (stor_id, " +
					"stor_name, " +
					"stor_address, " +
					"city, " +
					"state, " +
					"zip) VALUES('" + user.u.replace(stor_id1.getText(),"'","''") + "', " +
					"'" + user.u.replace(stor_name1.getText(),"'","''") + "', " +
					"'" + user.u.replace(stor_address1.getText(),"'","''") + "', " +
					"'" + (String)valuecity1.elementAt(city1.getSelectedIndex()) + "', " +
					"'" + (state1.getState() ? "CA" : (state11.getState() ? "WA" : (state12.getState() ? "OR" : " "))) + "', " +
					"'" + user.u.replace(zip1.getText(),"'","''") + "')";
		} else {
			if (keys == null || keys.length == 0) {
				user.mainmsg.setStatusMsg("You must first make a selection",5);
				return false;
			}
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_stores" +
					" WHERE stor_id='" + keys[0]+ "'" ;
			} else {
				SQL = "UPDATE dbo_stores SET stor_name = '" + user.u.replace(stor_name1.getText(),"'","''") + "', " +
					"stor_address = '" + user.u.replace(stor_address1.getText(),"'","''") + "', " +
					"city = '" + (String)valuecity1.elementAt(city1.getSelectedIndex()) + "', " +
					"state = '" + (state1.getState() ? "CA" : (state11.getState() ? "WA" : (state12.getState() ? "OR" : " "))) + "', " +
					"zip = '" + user.u.replace(zip1.getText(),"'","''") + "'" +
					" WHERE stor_id='" + keys[0]+ "'" ;
			}
		}

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR(" ");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		user.mainmsg.setStatusMsg("Accessing database...", 0);
		recCount = jaggSQL.execSQL(SQL, results);

		if (recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if (recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg("Record successfully added.",3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg("Record successfully removed.",3);
			} else {
				user.mainmsg.setStatusMsg("Record successfully updated.",3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		return true;

	}

	//
	//  Clear the screen fields for a new option
	//
	public void Columns1ClearFields() {

		stor_id1.setText("");
		stor_name1.setText("");
		stor_address1.setText("");
		city1.select(0);
		state1.setState(false);
		state11.setState(false);
		state12.setState(false);
		zip1.setText("");

	}

	//
	//  Load all of the Screen Choices
	//
	void Columns1LoadChoices() {

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR(" ");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");


		valuecity1 = new Vector(); 
		new JDPLoadChoice(user,jaggSQL,city1,"city","city","dbo_stores","(1=1)",valuecity1);
		new JDPLoadChoice(user,jaggSQL,zip1,"zip","zip","dbo_stores","(1=1)",null);
	}

	//
	//  Perform component validations
	//
	public boolean Columns1CheckFields() {


		return true;

	}

	//
	//  Create and load the Result List Panel
	//
	public void ResultList1Main() {

		String ResultList1sf = "stor_id";
		String[] ResultList1df = {};
		String ResultList1wc = "(1=1)";
		String[] ResultList1sct = {"Stor name"};
		String[] ResultList1sc = {"stor_name"};
		JDPJagg jaggSQL = new JDPJagg(user.jaggPath);
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		ResultList1 = new JDPSearchResults(user, targetPanel, true, jaggSQL, false, ResultList1sf, ResultList1df, ResultList1wc, ResultList1sct, ResultList1sc, ResultList1sc, "", true, "Total Entries:");
		int[] ResultList1icons = new int[8];
		ResultList1icons[0] = 3;
		ResultList1icons[1] = 5;
		ResultList1.setMinWidth(130);
		ResultList1.setIcons(ResultList1icons);
		ResultList1.setFromWhereClause(" FROM dbo_stores WHERE (1=1)");
		ResultList1.clearList("");
		ResultList1.loadList();
	}



}

